"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = statsD;

var _nodeStatsd = require("node-statsd");

var _nodeStatsd2 = _interopRequireDefault(_nodeStatsd);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function statsD() {
  var stat = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "";
  var client = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : new _nodeStatsd2.default();

  return function decorator(target, name, descriptor) {
    var fn = descriptor.value;

    var wrapper = function wrapper() {
      var now = new Date();

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      var promise = fn.apply(this, args);
      var statistic = (stat || this.name || "").toLowerCase();

      promise.then(function () {
        var after = new Date();
        var duration = after - now;

        if (duration > 0) {
          client.timing("open_planet.nodejs." + statistic + ".get.success.response_time", duration);
          client.increment("open_planet.nodejs." + statistic + ".get.success.count");
        }
      }).catch(function () {
        client.increment("open_planet.nodejs." + statistic + ".get.fail.count");
      });

      return promise;
    };

    descriptor.value = wrapper;
  };
}